<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Flujos</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Flujo?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list subheader>
              <v-subheader>Flujos del Perfil</v-subheader>
              <draggable
                v-model="flujosPerfil"
                v-bind="{
                  group: 'flujos',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200,
                }"
                handle=".drag"
                @change="onDragDrop"
                style="min-height: 400px;border: dashed 2px grey;"
              >
                <v-list-group
                  v-for="(flujoPerfil, indexFlujoPerfil) in flujosPerfil"
                  :key="indexFlujoPerfil + 1"
                  no-action
                  class="item"
                >
                  <template v-slot:activator>
                    <v-list-item-icon>
                      <v-icon @click="deleteAssociateFlujo(flujoPerfil)"
                        >mdi-trash-can</v-icon
                      >
                    </v-list-item-icon>
                    <v-list-item-content>
                      <v-list-item-title
                        v-text="
                          serviceCommons.titleCase(
                            flujoPerfil.flujo.descripcion
                          )
                        "
                      />
                    </v-list-item-content>
                  </template>

                  <v-list-item
                    v-for="(modulo, indexModulo) in flujoPerfil.flujo.modulos"
                    :key="indexModulo"
                  >
                    <v-list-item-content>
                      <v-list-item-title
                        v-text="modulo.descripcion"
                      ></v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                </v-list-group>
              </draggable>
            </v-list>
          </v-col>
          <v-col :sm="12" :md="6" :lg="6">
            <v-list subheader>
              <v-subheader>Flujos disponibles</v-subheader>
              <draggable
                v-model="flujos"
                v-bind="{
                  group: 'flujos',
                  draggable: '.item',
                  ghostClass: 'ghost',
                  animation: 200,
                }"
                @change="onDragDrop"
                style="max-height: 400px; min-height: 400px; overflow: auto; border: solid 2px grey;"
                handle=".drag"
                @start="drag = true"
                @end="drag = false"
              >
                <transition-group
                  type="transition"
                  :name="!drag ? 'flip-list' : null"
                >
                  <v-list-group
                    class="item"
                    v-for="(flujoPerfil, indexFlujoPerfil) in flujos"
                    :key="indexFlujoPerfil + 'index'"
                    no-action
                  >
                    <template v-slot:activator>
                      <v-list-item-icon>
                        <v-icon class="drag">mdi-cursor-move</v-icon>
                      </v-list-item-icon>
                      <v-list-item-content>
                        <v-list-item-title
                          v-text="
                            serviceCommons.titleCase(
                              flujoPerfil.flujo.descripcion
                            )
                          "
                        />
                      </v-list-item-content>
                    </template>

                    <v-list-item
                      v-for="(modulo, indexModulo) in flujoPerfil.flujo.modulos"
                      :key="indexModulo"
                    >
                      <v-list-item-content>
                        <v-list-item-title
                          v-text="modulo.descripcion"
                        ></v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-divider
                      v-if="indexFlujoPerfil + 1 < flujos.length"
                      :key="indexFlujoPerfil + 2"
                    />
                  </v-list-group>
                </transition-group>
              </draggable>
            </v-list>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
    </div>
  </div>
</template>
<style scoped>
.button {
  margin-top: 35px;
}
.flip-list-move {
  transition: transform 0.5s;
}
.no-move {
  transition: transform 0s;
}
.ghost {
  opacity: 0.5;
  background: #c8ebfb;
}
.list-group {
  min-height: 20px;
}
.list-group-item {
  cursor: move;
}
.list-group-item i {
  cursor: pointer;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import draggable from "vuedraggable";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-FlujosPerfil",
  components: {
    draggable,
  },
  data() {
    return {
      moment: moment,
      drag: null,
      perfil: null,
      removedFlujo: null,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios",
          },
        },
        {
          text: "Perfiles",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_perfiles_configuracion",
          },
        },
        {
          text: "Configuracion Flujos",
          disabled: true,
        },
      ],
      flujos: [],
      flujosPerfil: [],
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    initValues() {
      this.breadcrumbs.push({
        text: this.perfil.descripcion,
        disabled: true,
      });
    },
    getFlujosDisponibles() {
      var self = this;
      axios
        .get("/flujo/perfil/secure/get/available/" + this.perfil.id_perfil)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujosDisponibles(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujosDisponibles(data) {
      if (data) {
        this.flujos = data;
      }
    },
    getFlujosAsociados() {
      var self = this;
      axios
        .get("/flujo/perfil/secure/get/associated/" + this.perfil.id_perfil)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujosAsociados(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujosAsociados(data) {
      if (data) {
        this.flujosPerfil = data;
      }
    },
    postAssociateFlujo(flujo) {
      var self = this;
      axios
        .post("/flujo/perfil/secure/post", flujo)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.flujosPerfil = self.flujosPerfil.map((item) => {
                if (item.flujo.id_flujo === data.flujo.id_flujo) {
                  item.id_flujo_perfil = data.id_flujo_perfil;
                }
                return item;
              });
            } else {
              self.rollbackAdd();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    deleteAssociateFlujo(itemToDelete) {
      var self = this;
      axios
        .delete("/flujo/perfil/secure/delete", { data: itemToDelete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.deleteFlujoPerfil(itemToDelete);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    rollbackAdd() {
      let itemToAdd = this.removedFlujo.element;
      if (this.flujosPerfil) {
        this.flujosPerfil = this.flujosPerfil.filter((item) => {
          if (item.flujo.id_flujo !== itemToAdd.flujo.id_flujo) {
            return item;
          }
        });
        this.flujos.splice(this.removedFlujo.oldIndex, 0, itemToAdd);
      }
    },
    deleteFlujoPerfil(itemToDelete) {
      if (this.flujosPerfil) {
        let flujoPerfilToDelete;
        this.flujosPerfil = this.flujosPerfil.filter((item) => {
          if (item.flujo.id_flujo === itemToDelete.flujo.id_flujo) {
            flujoPerfilToDelete = item;
          } else {
            return item;
          }
        });
        if (flujoPerfilToDelete) {
          this.flujos.push(flujoPerfilToDelete);
        }
      }
    },
    onDragDrop(event) {
      if (event.added) {
        this.postAssociateFlujo(event.added.element);
      }
      if (event.removed) {
        this.removedFlujo = event.removed;
      }
    },
    onCreated() {
      if (this.$route.params.perfil) {
        this.perfil = this.serviceCommons.base64ToObject(
          this.$route.params.perfil
        );
      }
      this.initValues();
      this.getFlujosDisponibles();
      this.getFlujosAsociados();
    },
  },
  created() {
    this.onCreated();
  },
};
</script>
